﻿using System;
using System.Collections.Generic;
using Microsoft.EntityFrameworkCore;

namespace AvaloniaBaseTeacher.Models;

public partial class _43pProvalenkoContext : DbContext
{
    public _43pProvalenkoContext()
    {
    }

    public _43pProvalenkoContext(DbContextOptions<_43pProvalenkoContext> options)
        : base(options)
    {
    }

    public virtual DbSet<Course> Courses { get; set; }

    public virtual DbSet<Course1Teacher> Course1Teachers { get; set; }

    public virtual DbSet<Discipline> Disciplines { get; set; }

    public virtual DbSet<Discipline1Teacher> Discipline1Teachers { get; set; }

    public virtual DbSet<Gender> Genders { get; set; }

    public virtual DbSet<Teacher> Teachers { get; set; }

    protected override void OnConfiguring(DbContextOptionsBuilder optionsBuilder)
#warning To protect potentially sensitive information in your connection string, you should move it out of source code. You can avoid scaffolding the connection string by using the Name= syntax to read it from configuration - see https://go.microsoft.com/fwlink/?linkid=2131148. For more guidance on storing connection strings, see https://go.microsoft.com/fwlink/?LinkId=723263.
        => optionsBuilder.UseNpgsql("Host=edu.pg.ngknn.local;Port=5432;Database=43P_Provalenko;Username=43P;Password=444444");

    protected override void OnModelCreating(ModelBuilder modelBuilder)
    {
        modelBuilder.Entity<Course>(entity =>
        {
            entity.HasKey(e => e.IdCourse).HasName("course_pk");

            entity.ToTable("course");

            entity.Property(e => e.IdCourse).HasColumnName("id_course");
            entity.Property(e => e.Course1)
                .HasColumnType("character varying")
                .HasColumnName("course");
            entity.Property(e => e.Hours).HasColumnName("hours");
        });

        modelBuilder.Entity<Course1Teacher>(entity =>
        {
            entity.HasKey(e => e.Id).HasName("course1_teachers_pk");

            entity.ToTable("course1.teachers");

            entity.Property(e => e.Id).HasColumnName("id");
            entity.Property(e => e.IdCourse)
                .ValueGeneratedOnAdd()
                .HasColumnName("id_course");
            entity.Property(e => e.IdTeacher)
                .ValueGeneratedOnAdd()
                .HasColumnName("id_teacher");

            entity.HasOne(d => d.IdCourseNavigation).WithMany(p => p.Course1Teachers)
                .HasForeignKey(d => d.IdCourse)
                .HasConstraintName("course1_teachers_course_fk");

            entity.HasOne(d => d.IdTeacherNavigation).WithMany(p => p.Course1Teachers)
                .HasForeignKey(d => d.IdTeacher)
                .HasConstraintName("course1_teachers_teachers_fk");
        });

        modelBuilder.Entity<Discipline>(entity =>
        {
            entity.HasKey(e => e.IdDiscipline).HasName("discipline_pk");

            entity.ToTable("discipline");

            entity.Property(e => e.IdDiscipline).HasColumnName("id_discipline");
            entity.Property(e => e.NameDiscipline)
                .HasColumnType("character varying")
                .HasColumnName("name_discipline");
        });

        modelBuilder.Entity<Discipline1Teacher>(entity =>
        {
            entity.HasKey(e => e.Id).HasName("discipline1_teachers_pk");

            entity.ToTable("discipline1_teachers");

            entity.Property(e => e.Id).HasColumnName("id");
            entity.Property(e => e.IdDiscipline)
                .ValueGeneratedOnAdd()
                .HasColumnName("id_discipline");
            entity.Property(e => e.IdTeacher)
                .ValueGeneratedOnAdd()
                .HasColumnName("id_teacher");

            entity.HasOne(d => d.IdDisciplineNavigation).WithMany(p => p.Discipline1Teachers)
                .HasForeignKey(d => d.IdDiscipline)
                .HasConstraintName("discipline1_teachers_discipline_fk");

            entity.HasOne(d => d.IdTeacherNavigation).WithMany(p => p.Discipline1Teachers)
                .HasForeignKey(d => d.IdTeacher)
                .HasConstraintName("discipline1_teachers_teachers_fk");
        });

        modelBuilder.Entity<Gender>(entity =>
        {
            entity.HasKey(e => e.IdGender).HasName("gender1_pk");

            entity.ToTable("gender");

            entity.Property(e => e.IdGender)
                .HasDefaultValueSql("nextval('gender1_id_gender_seq'::regclass)")
                .HasColumnName("id_gender");
            entity.Property(e => e.GenderName)
                .HasColumnType("character varying")
                .HasColumnName("gender_name");
        });

        modelBuilder.Entity<Teacher>(entity =>
        {
            entity.HasKey(e => e.IdTeacher).HasName("teachers_pk");

            entity.ToTable("teachers");

            entity.Property(e => e.IdTeacher).HasColumnName("id_teacher");
            entity.Property(e => e.Birthday)
                .HasColumnType("timestamp without time zone")
                .HasColumnName("birthday");
            entity.Property(e => e.Email)
                .HasColumnType("character varying")
                .HasColumnName("email");
            entity.Property(e => e.Experience).HasColumnName("experience");
            entity.Property(e => e.Gender)
                .ValueGeneratedOnAdd()
                .HasColumnName("gender");
            entity.Property(e => e.Name).HasColumnType("character varying");
            entity.Property(e => e.Patronymic)
                .HasColumnType("character varying")
                .HasColumnName("patronymic");
            entity.Property(e => e.Phone)
                .HasColumnType("character varying")
                .HasColumnName("phone");
            entity.Property(e => e.Surname)
                .HasColumnType("character varying")
                .HasColumnName("surname");

            entity.HasOne(d => d.GenderNavigation).WithMany(p => p.Teachers)
                .HasForeignKey(d => d.Gender)
                .OnDelete(DeleteBehavior.ClientSetNull)
                .HasConstraintName("teachers_gender1_fk");
        });

        OnModelCreatingPartial(modelBuilder);
    }

    partial void OnModelCreatingPartial(ModelBuilder modelBuilder);
}
